<?php
// $Id: reptag_ajax.inc,v 1.4.2.1 2006/10/20 08:56:33 profix898 Exp $

$xajax_inc = variable_get('reptag_xajax_path', drupal_get_path('module', 'reptag').'/xajax/xajax.inc.php');
if (file_exists($xajax_inc)) {
  require_once ($xajax_inc);
}

function _reptag_ajax_site_init() {

  if (!class_exists('xajax')) {
    return FALSE;
  }
  
  $xajax = new xajax();
  
  if (variable_get('reptag_debug', 0)) {
    $xajax->debugOn();
  }
  
  $xajax->registerFunction('_reptag_ajax_tagedit');
  $xajax->registerFunction('_reptag_ajax_tagremove');
  $xajax->registerFunction('_reptag_ajax_tagadd');
  $xajax->registerFunction('_reptag_ajax_exclude');
  $xajax->registerFunction('_reptag_ajax_exclude_add');
  $xajax->registerFunction('_reptag_ajax_exclude_remove');
  $xajax->registerFunction('_reptag_ajax_exclude_close');
  
  drupal_set_html_head($xajax->getJavascript(dirname(variable_get('reptag_xajax_path', drupal_get_path('module', 'reptag').'/xajax/xajax.inc.php'))));
  drupal_set_html_head('<script type="text/javascript" src="'.drupal_get_path('module', 'reptag').'/reptag_helper.js"></script>');

  $xajax->processRequests();
  
  return TRUE;
}

function _reptag_ajax_tagedit($id, $name, $value, $uid) {
  $objResponse = new xajaxResponse();
  
  $reptag_table = array_keys(_reptag_table_load(array($uid), 2));
  _reptag_table_del('#\$'.$reptag_table[$id].'\$#si', $uid);
  _reptag_table_set('#\$'.strtoupper($name).'\$#si', $value, $uid);
  
  $objResponse->addScript('location.reload(true);');
  return $objResponse;
}

function _reptag_ajax_tagremove($id, $uid) {
  $objResponse = new xajaxResponse();

  $reptag_table = array_keys(_reptag_table_load(array($uid), 2));
  _reptag_table_del('#\$'.$reptag_table[$id].'\$#si', $uid);
  
  $objResponse->addScript('location.reload(true);');
  return $objResponse;
}

function _reptag_ajax_tagadd($name, $value, $uid) {
  $objResponse = new xajaxResponse();

  if (!empty($name)) {
    _reptag_table_set('#\$'.strtoupper($name).'\$#si', $value, $uid);  
    $objResponse->addScript('location.reload(true);');
  }
  
  return $objResponse;
}

function _reptag_ajax_exclude($action, $rid) {
  $objResponse = new xajaxResponse();
  
  $finishbtn = array(
    '#type' => 'reptag_button',
    '#value' => t('Finish'),
    '#attributes' => array(
      'onclick' => 'xajax__reptag_ajax_exclude_close('.$action.');'),
    '#button_type' => 'reptag_button'
  );
  
  if ($action) {
    //add exclude
    
    $objResponse->addAssign('roles-exclude-rid', 'value', $rid);
    
    $roles = _reptag_roles_load();
    foreach ($roles as $role => $rid) {
      $objResponse->addAppend('edit-roles-exclude-table-'.$rid.'-add', 'disabled', 'disabled');
      $objResponse->addAppend('edit-roles-exclude-table-'.$rid.'-remove', 'disabled', 'disabled');
    }
    
    $objResponse->addScript('reptag_exclude_add_show();');
    $objResponse->addCreate('roles-exclude-container', 'div', 'btnFinish');
    $objResponse->addAppend('btnFinish', 'innerHTML', '<br />'.form_render($finishbtn));  
  
  } else {
    //remove exclude

    $exclude_tags = _reptag_exclude_loadtags($rid);
    
    if (count($exclude_tags) > 0) {
    
      $exclude_tags = array_chunk($exclude_tags, 3, TRUE);
      foreach ($exclude_tags as $tags) {
        $row = array();
        $tag = each($tags);
        $table['colA'] = array(
          '#value' => $tag[1],
          '#prefix' => '<a id="exclude-tags-remove-'.$tag[0].'" onclick="javascript:xajax__reptag_ajax_exclude_remove('.$rid.', '.$tag[0].');">',
          '#suffix' => '</a>',
        );
        $tag = each($tags);
        $table['colB'] = array(
          '#value' => $tag[1],
          '#prefix' => '<a id="exclude-tags-remove-'.$tag[0].'" onclick="javascript:xajax__reptag_ajax_exclude_remove('.$rid.', '.$tag[0].');">',
          '#suffix' => '</a>',
        );
        $tag = each($tags);
        $table['colC'] = array(
          '#value' => $tag[1],
          '#prefix' => '<a id="exclude-tags-remove-'.$tag[0].'" onclick="javascript:xajax__reptag_ajax_exclude_remove('.$rid.', '.$tag[0].');">',
          '#suffix' => '</a>',
        );
        $row[] = form_render($table['colA']);
        $row[] = form_render($table['colB']);
        $row[] = form_render($table['colC']);
        $rows[] = $row;
      }
      $header = array('', '', '');
      $objResponse->addCreate('roles-exclude-container', 'div', 'tagHelp');
      $objResponse->addAppend('tagHelp', 'innerHTML', t('<i>Click to remove</i>'));
      $objResponse->addCreate('roles-exclude-container', 'div', 'tagTable');
      $objResponse->addAppend('tagTable', 'innerHTML', theme_table($header, $rows));
      
      $roles = _reptag_roles_load();
      foreach ($roles as $role => $rid) {
        $objResponse->addAppend('edit-roles-exclude-table-'.$rid.'-add', 'disabled', 'disabled');
        $objResponse->addAppend('edit-roles-exclude-table-'.$rid.'-remove', 'disabled', 'disabled');
      }
      
      $objResponse->addCreate('roles-exclude-container', 'div', 'btnFinish');
      $objResponse->addAppend('btnFinish', 'innerHTML', '<br />'.form_render($finishbtn));
      
    }
  
  }

  return $objResponse;
}

function _reptag_ajax_exclude_add($rid, $value) {
  $objResponse = new xajaxResponse();
  
  if (!empty($value)) {
    $exclude_tags = _reptag_exclude_loadtags($rid);
    array_push($exclude_tags, strtoupper($value));
    _reptag_exclude_storetags($rid, $exclude_tags);
    $objResponse->addAssign('edit-roles-exclude-container-add-value', 'value', '');  	
    
    $objResponse->addAssign('edit-roles-exclude-table-'.$rid.'-tags', 'value', _reptag_tags_implode($exclude_tags));
  }

  return $objResponse;
}

function _reptag_ajax_exclude_remove($rid, $tid) {
  $objResponse = new xajaxResponse();
  
  $exclude_tags = _reptag_exclude_loadtags($rid);
  unset($exclude_tags[$tid]);
  _reptag_exclude_storetags($rid, $exclude_tags);
  
  $objResponse->addRemove('exclude-tags-remove-'.$tid);
  $objResponse->addAssign('edit-roles-exclude-table-'.$rid.'-tags', 'value', _reptag_tags_implode($exclude_tags));
  
  return $objResponse;
}

function _reptag_ajax_exclude_close($action) {
  $objResponse = new xajaxResponse();
  
  if ($action) {
    //add exclude
    $objResponse->addScript('reptag_exclude_add_hide();');
    $objResponse->addRemove('btnFinish');
  } else {
    //remove exclude
    $objResponse->addRemove('tagTable');
    $objResponse->addRemove('tagHelp');
    $objResponse->addRemove('btnFinish');
  }
  
  $roles = _reptag_roles_load();
  foreach ($roles as $role => $rid) {
    $objResponse->addAssign('edit-roles-exclude-table-'.$rid.'-tags', 'value', _reptag_exclude_loadtags_string($rid));
    $objResponse->addClear('edit-roles-exclude-table-'.$rid.'-add', 'disabled');
    $objResponse->addClear('edit-roles-exclude-table-'.$rid.'-remove', 'disabled');
  }
  
  return $objResponse;
}

?>
